/**
 * 最初の著者:: トゥイー
 * リポジトリ情報:: $Id: MapIterator.hpp 11 2011-05-14 02:11:18Z yutaka_at_home $
 * 著作権:: Copyright (C) Ownway.info, 2011. All rights reserved.
 * ライセンス:: CPL(Common Public Licence)
 */

#ifndef _UTILITY_MAP_ITERATOR_HPP_
#define _UTILITY_MAP_ITERATOR_HPP_

namespace Utility {

	/**
	 * map::iteratorのfirstを指し示す反復子です。
	 *
	 * @author トゥイー
	 */
	template<class Iterator, class ValueType>
	class MapIteratorFirst {
	private:
		/**
		 * ラップする反復子です。
		 */
		Iterator m_i;

	public:
		/**
		 * ラッパーを構築します。
		 */
		MapIteratorFirst(Iterator i) : m_i(i) {
		}

	public:
		/**
		 * 反復子を(前置)インクリメントします。
		 */
		MapIteratorFirst<Iterator, ValueType>& operator++() {
			++m_i;
			return *this;
		}

		/**
		 * 反復子を(後置)インクリメントします。
		 */
		MapIteratorFirst<Iterator, ValueType>& operator++(int dummy) {
			Iterator i = m_i;
			++m_i;
			return i;
		}

		/**
		 * 反復子の内容を取得します。
		 */
		const ValueType& operator*() const {
			return m_i->first;
		}

		/**
		 * 反復子の内容にアクセスします。
		 */
		ValueType* operator->() const {
			return &m_i->first;
		}

	public:
		/**
		 * 等号判定です。
		 */
		bool operator==(const MapIteratorFirst<Iterator, ValueType>& i) {
			return m_i == i.m_i;
		}

		/**
		 * 不等号判定です。
		 */
		bool operator!=(const MapIteratorFirst<Iterator, ValueType>& i) {
			return m_i != i.m_i;
		}
	};

	/**
	 * map::iteratorのsecondを指し示す反復子です。
	 *
	 * @author トゥイー
	 */
	template<class Iterator, class ValueType>
	class MapIteratorSecond {
	private:
		/**
		 * ラップする反復子です。
		 */
		Iterator m_i;

	public:
		/**
		 * ラッパーを構築します。
		 */
		MapIteratorSecond(Iterator i) : m_i(i) {
		}

	public:
		/**
		 * 反復子を(前置)インクリメントします。
		 */
		MapIteratorSecond<Iterator, ValueType>& operator++() {
			m_i++;
			return *this;
		}

		/**
		 * 反復子を(後置)インクリメントします。
		 */
		MapIteratorSecond<Iterator, ValueType>& operator++(int dummy) {
			Iterator i = m_i;
			++m_i;
			return i;
		}

		/**
		 * 反復子の内容を取得します。
		 */
		const ValueType& operator*() const {
			return m_i->second;
		}

		/**
		 * 反復子の内容にアクセスします。
		 */
		ValueType* operator->() const {
			return &m_i->second;
		}

	public:
		/**
		 * 等号判定です。
		 */
		bool operator==(const MapIteratorSecond<Iterator, ValueType>& i) {
			return m_i == i.m_i;
		}

		/**
		 * 不等号判定です。
		 */
		bool operator!=(const MapIteratorSecond<Iterator, ValueType>& i) {
			return m_i != i.m_i;
		}
	};

	/**
	 * map::const_iteratorのfirstを指し示す定数反復子です。
	 *
	 * @author トゥイー
	 */
	template<class Iterator, class ValueType>
	class ConstMapIteratorFirst {
	private:
		/**
		 * ラップする反復子です。
		 */
		Iterator m_i;

	public:
		/**
		 * ラッパーを構築します。
		 */
		ConstMapIteratorFirst(Iterator i) : m_i(i) {
		}

	public:
		/**
		 * 反復子を(前置)インクリメントします。
		 */
		ConstMapIteratorFirst<Iterator, ValueType>& operator++() {
			++m_i;
			return *this;
		}

		/**
		 * 反復子を(後置)インクリメントします。
		 */
		ConstMapIteratorFirst<Iterator, ValueType>& operator++(int dummy) {
			Iterator i = m_i;
			++m_i;
			return i;
		}

		/**
		 * 反復子の内容を取得します。
		 */
		const ValueType& operator*() const {
			return m_i->first;
		}

		/**
		 * 反復子の内容にアクセスします。
		 */
		const ValueType* operator->() const {
			return &m_i->first;
		}

	public:
		/**
		 * 等号判定です。
		 */
		bool operator==(const ConstMapIteratorFirst<Iterator, ValueType>& i) {
			return m_i == i.m_i;
		}

		/**
		 * 不等号判定です。
		 */
		bool operator!=(const ConstMapIteratorFirst<Iterator, ValueType>& i) {
			return m_i != i.m_i;
		}
	};

	/**
	 * map::const_iteratorのsecondを指し示す定数反復子です。
	 *
	 * @author トゥイー
	 */
	template<class Iterator, class ValueType>
	class ConstMapIteratorSecond {
	private:
		/**
		 * ラップする反復子です。
		 */
		Iterator m_i;

	public:
		/**
		 * ラッパーを構築します。
		 */
		ConstMapIteratorSecond(Iterator i) : m_i(i) {
		}

	public:
		/**
		 * 反復子を(前置)インクリメントします。
		 */
		ConstMapIteratorSecond<Iterator, ValueType>& operator++() {
			++m_i;
			return *this;
		}

		/**
		 * 反復子を(後置)インクリメントします。
		 */
		ConstMapIteratorSecond<Iterator, ValueType>& operator++(int dummy) {
			Iterator i = m_i;
			++m_i;
			return i;
		}

		/**
		 * 反復子の内容を取得します。
		 */
		const ValueType& operator*() const {
			return m_i->second;
		}

		/**
		 * 反復子の内容にアクセスします。
		 */
		const ValueType* operator->() const {
			return &m_i->second;
		}

	public:
		/**
		 * 等号判定です。
		 */
		bool operator==(const ConstMapIteratorSecond<Iterator, ValueType>& i) {
			return m_i == i.m_i;
		}

		/**
		 * 不等号判定です。
		 */
		bool operator!=(const ConstMapIteratorSecond<Iterator, ValueType>& i) {
			return m_i != i.m_i;
		}
	};

}  // namespace Utility

#endif
